(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./column", "./tables", "./expr", "./util"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./column"), require("./tables"), require("./expr"), require("./util"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.column, global.tables, global.expr, global.util);
    global._delete = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _column, _tables, _expr, _util) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.deleteToSQL = deleteToSQL;

  function deleteToSQL(stmt) {
    const clauses = ['DELETE'];
    const {
      columns,
      from,
      table,
      where
    } = stmt;
    const columnInfo = (0, _column.columnsToSQL)(columns, from);
    clauses.push(columnInfo);

    if (Array.isArray(table)) {
      if (!(table.length === 1 && table[0].addition === true)) clauses.push((0, _tables.tablesToSQL)(table));
    }

    clauses.push((0, _util.commonOptionConnector)('FROM', _tables.tablesToSQL, from));
    clauses.push((0, _util.commonOptionConnector)('WHERE', _expr.exprToSQL, where));
    return clauses.filter(_util.hasVal).join(' ');
  }
});