(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./column", "./util"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./column"), require("./util"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.column, global.util);
    global.struct = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _column, _util) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.structToSQL = structToSQL;

  function structToSQL(expr) {
    const {
      definition,
      type,
      columns
    } = expr;
    const result = [(0, _util.toUpper)(type)];

    if (typeof definition === 'object') {
      result.push('');
    }

    result.push(`(${(0, _column.columnsToSQL)(columns)})`);
    return result.filter(_util.hasVal).join('');
  }
});